#pragma once
#include "B4RDefines.h"
#include "RCSwitch.h"

    //~shortname:RCSwitch
    //~Event: DataAvailable()
    //~Version: 1.0 
    //~Author - 
    //Libray from Arduino

namespace B4R {

    class B4RRCSwitch{
        private:
            uint8_t backend[sizeof(RCSwitch)];
            RCSwitch* rcs;
            PollerNode pnode;
            SubVoidVoid DataAvailableSub;
            static void looper(void* b);
            RCSwitch::Protocol protocol; 
        public: 
            void Initialize();
            void enableReceive(SubVoidVoid DataAvailableSub, int interrupt);
            void switchOn(int nGroupNumber, int nSwitchNumber);
            void switchOff(int nGroupNumber, int nSwitchNumber);
            void switchOn1(B4RString* sGroup, int nSwitchNumber);
            void switchOff1(B4RString* sGroup, int nSwitchNumber);
            void switchOn2(char sFamily, int nGroup, int nDevice);
            void switchOff2(char sFamily, int nGroup, int nDevice);
            void switchOn3(B4RString* sGroup, B4RString* sDevice);
            void switchOff3(B4RString* sGroup, B4RString* sDevice);
            void switchOn4(char sGroup, int nDevice);
            void switchOff4(char sGroup, int nDevice);
            void sendTriState(B4RString* sCodeWord);
            void send(ulong code, uint length);
            void send1(B4RString* sCodeWord);
            void disableReceive();
            void resetAvailable();
            ulong getReceivedValue();
            uint getReceivedBitlength();
            uint getReceivedDelay();
            uint getReceivedProtocol();
            ArrayUInt* getReceivedRawdata();
            void enableTransmit(int nTransmitterPin);
            void disableTransmit();
            void setPulseLength(int nPulseLength);
            void setRepeatTransmit(int nRepeatTransmit);
            void setReceiveTolerance(int nPercent);
            void ProtocolSet(uint16_t pulseLength, uint8_t syncFactor_high, uint8_t syncFactor_low, uint8_t zero_high, uint8_t zero_low, uint8_t one_high, int8_t one_low, bool invertedSignal );
            void setProtocol1(int nProtocol);
            void setProtocol2(int nProtocol, int nPulseLength);
    };
}
